#pragma once

#define DEF_LOGO_RIGHT_REL_POS_X			(9)
#define DEF_LOGO_RIGHT_REL_POS_Y			(12)
#define DEF_STATUS_REL_POS_X				(11)
#define DEF_NAME_REL_TOP_POS_Y				(11)
#define DEF_NICKNAME_REL_BOT_POS_Y			(11)
#define DEF_NICKNAME_REL_RIGHT_POS_X		(24)
#define DEF_NAME_REL_LEFT_POS_X				(3)
#define DEF_NAME_REL_RIGHT_POS_X			(8)
#define DEF_NAME_NICK_GAP_Y					(5)
#define DEF_TEXT_LINE_COUNT					(2)
#define DEF_IPT_STATUS_BG_GAP_X				(3)
#define DEF_IPT_STATUS_BG_GAP_Y				(3)

#define DEF_ME_NAME_FONT_SIZE				(10.5)
#define DEF_NICKNAME_FONT_SIZE				(10)

#define DEF_EDIT_NICK_BG_OVER_COLOR			Color(255, 136, 136, 136)
#define DEF_EDIT_NICK_BG_CLICK_COLOR		Color(255, 0, 138, 255)

#define ID_EDIT_NICKNAME					(0x7001)



// CInfoAboutMeWnd
class CInfoAboutMeWnd : public CWnd
{
	DECLARE_DYNAMIC(CInfoAboutMeWnd)

public:
	CInfoAboutMeWnd();
	virtual ~CInfoAboutMeWnd();

private:
	// BG
	Image*							m_pImgBG;
	Image*							m_pImgLogo;

	Image*							m_pImgStatusOverBG;
	Image*							m_pImgStatusDraw;
	Image*							m_pImgStatusFrom;
	Image*							m_pImgStatusTo;
	Image*							m_pImgIPTOverBG;
	Image*							m_pImgIPTStatus;

	Color							m_crEditNickBGOver;
	Color							m_crEditNickBGClick;

	// dimension
	CRect							m_rtFrame;
	CRect							m_rtLogo;
	CRect							m_rtStatus;
	CRect							m_rtName;
	CRect							m_rtDepartment;
	CRect							m_rtNickName;
	CRect							m_rtEdit;

	// status
	int								m_nStatusRotate;
	BOOL							m_bStatusRotateFlip;
	CRect							m_rtIPTStatus;

	// edit
	CEdit							m_editNickName;
	COLORREF						m_crOutline;
	BOOL							m_bEditNickName;

	// attribute
	CString							m_strName;
	CString							m_strDepartment;
	CString							m_strNickName;
	CString							m_strNickNameAbbr;
	CString							m_strEmptyNickName;

	GTUserStatusType				m_gtStatus;
	NTIPTStatusType					m_myIPTStatus;

	// tracking
	BOOL							m_bTracking;
	BOOL							m_bHoverStatus;
	BOOL							m_bHoverIPT;
	BOOL							m_bDownStatus;
	BOOL							m_bHoverNickName;
	BOOL							m_bDownNickName;

protected:
	DECLARE_MESSAGE_MAP()

	virtual BOOL	OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL	PreTranslateMessage(MSG* pMsg);
	void			RotateImageWithInterval(DWORD dwMilliseconds);

	CCriticalSection	m_csTimerEvent;	

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnDestroy();

	BOOL							IsMobileOnline();
	void							SetName(CString strName);
	void							SetIPT();
	CString							GetName()										{ return m_strName; }
	void							SetDepartment(CString strDepartment);
	CString							GetDepartment()									{ return m_strDepartment; }
	void							SetNickName(CString strNickName);
	CString							GetNickName()									{ return m_strNickName; }
	void							SetEmptyNickNameText(CString strEmptyNickName);
	CString							GetEmptyNickNameText()							{ return m_strEmptyNickName; }

	void							UpdateNickName();
	void							SetAboutMeStatus(GTUserStatusType gtStatus);
	void							SetAboutIPTStatus(NTIPTStatusType iptStatus);
	void							AllocateStatusImage();
	void							AllocateIPTStatusImage();
	void							SetImgBGPath(CString strFileName);
	void							SetImgLogoPath(CString strFileName);
	void							SetImgStatusOverBGPath(CString strFileName);
	void							SetImgStatusPath(CString strFileName);
	void							SetImgIPTStatusPath(CString strFileName);
	void							SetImgIPTOverBGPath(CString strFileName);

	void							RedrawStatus();
	void							RedrawIPTStatus();
	void							RedrawNickName();

	int								GetImgBGWidth();
	int								GetImgBGHeight();
	CRect							GetStatusRect()						{ return m_rtStatus; }
	CRect							GetIPTStatusRect()					{ return m_rtIPTStatus;}
	void							SetOutlineColor(COLORREF cr)		{ m_crOutline = cr; }
	COLORREF						GetOutlineColor()					{ return m_crOutline; }
	void							SetEditNickName(BOOL bEdit);
	BOOL							GetEditNickName()					{ return m_bEditNickName; }
	GTUserStatusType				GetMyStatus() { return m_gtStatus; }

};
